tool
extends StaticBody2D

class_name Floor,"res://Resources/floor_grass.png" 

enum Type { NORMAL, ONEWAY }

export (Type)    var type                  : int = Type.NORMAL
export (Texture) var texture               : Texture               setget set_texture, get_texture
export (float,1.0,512.0) var width         : float = 1.0           setget set_width, get_width
export (float,-128.0,128.0) var offset     : float = 0.0           setget set_offset, get_offset
export (float,0.0,10.0) var texture_offset : float = 0.0           setget set_texture_offset, get_texture_offset

func set_texture(new_texture):
	texture = new_texture
	_update_sprite()
	if $Sprite: $Sprite.texture = new_texture

func get_texture():
	return texture

func set_width(new_width):
	width = new_width
	_update_sprite()
	if $CollisionShape2D:
		$CollisionShape2D.scale.x = width
		$CollisionShape2D.scale.y = 1.0
		$CollisionShape2D.position.x = 0.0

func get_width():
	return width
	
func get_offset():
	return offset
	
func set_offset(_offset):
	offset = _offset
	if $CollisionShape2D: $CollisionShape2D.position.y = offset
	
func get_texture_offset():
	return texture_offset
	
func set_texture_offset(_texture_offset):
	texture_offset = _texture_offset
	_update_sprite()

func _update_sprite():
	if $Sprite:
		if texture:
			$Sprite.region_rect.size.x = width * 128.0
			$Sprite.region_rect.size.y = texture.get_height()
			$Sprite.position.x = -width * 64.0
			$Sprite.position.y = -texture.get_height()
			$Sprite.region_rect.position.x = texture_offset * 128.0

func _ready():
	add_to_group("floor")
	add_to_group("noclimb")
	if type == Type.ONEWAY:
		$CollisionShape2D.one_way_collision = true
		add_to_group("oneway")
